##########################################################################
# htmlӸ
##########################################################################
sub html_head {
    local($cgi_name, $cgi_ver);
    my $cgi_type = shift;
   
    if($cgi_type eq "bdr_board") {
       $cgi_name = "Board";
       $cgi_ver  = $gVerBoard;
       $cgi_css  = "bdr_board.css";
    }
    elsif($cgi_type eq "bdr_guest") {
       $cgi_name = "Guest";
       $cgi_ver  = $gVerGuest;
       $cgi_css  = "bdr_guest.css";       
    }
    elsif($cgi_type eq "bdr_link") {
       $cgi_name = "Link";
       $cgi_ver  = $gVerLink;
       $cgi_css  = "bdr_link.css";       
    }
    elsif(($cgi_type eq "bdr_admin") || ($cgi_type eq "bdr_member")) {
       $cgi_name = "CGI";
       $cgi_ver  = $gVerCGI;
       $cgi_css  = "bdr_admin.css";       
    }

    print "Content-type: text/html\n\n";
    &copyright_contents;
    print "\n<html>\n <head>\n";
    print "  <title>Beomdori's $cgi_name $cgi_ver</title>\n";    
    print "  <meta http-equiv=\"description\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "  <style type='text/css'>\n";
    print "   <!--\n";	
    print "    BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 98% 98%}\n";
    print "   -->\n";    
    print "    .hide_preview {padding:3px; position:absolute; visibility:hidden; border:outset 1px white; background-color: #eeeeee;}" if($gUsePreview eq "checked");
    print "  </style>\n" ;    
    print "  <link rel=\"stylesheet\" type=\"text/css\" href=\"./$cgi_css\">\n";
    
    print "    
  <script language=\"JavaScript\">
  <!--           
    function clearField(field){ 
      if (field.value == field.defaultValue) {  field.value = ''; } 
    }
    function checkField(field){ 
      if (field.value == '') { field.value = field.defaultValue; } 
    }
    function NewWin(Left,Top,Width,Height,Name,URL) { 
      window.open(URL,Name,'resizable=no,scrollbars=no,status=0,toolbar=no,location=no,directories=no,menubar=no,left='+Left+',top='+Top+',width='+Width+',height='+Height);
    }";
           
    if($cgi_type eq "bdr_admin") {
      print "
      var NUM = \"0123456789\"; 
      var ALPHA = \"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_-\";
      
      function TypeCheck(s, spc) {
           var i;
      
           for(i=0; i< s.length; i++) {
                   if (spc.indexOf(s.substring(i, i+1)) < 0) {
                           return false;
                   }
           }        
           return true;       
      }
      
      function DBCheckField() {
           var f = document.createDB;
      
           if (!TypeCheck(f.db.value, ALPHA+NUM)) {
             alert(\"DB   ڷθ   ֽϴ.\");
             return false;
           }
           return true;
      }";
     }
     
     if(($cgi_type eq "bdr_board") && ($gUsePreview eq "checked")) {
         require "./lib/bd_preview.cgi";
         &bd_preview;       	
     }      

     print "
-->\n
 </script>
</head>\n\n";

    $gBackColor = "#ffffff" unless($gBackColor);
    print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return true'><br><center>\n"; 
    
    if($cgi_type eq "bdr_board") {
       print "<table width=$gTableWidth border=0 align=$gAlignType><tr><td>\n";    	
       if($gTitleUse eq "checked") {
          print "<br><center><img src=$gIMG_Board/title.gif border=0></center><p>\n";
       }
    }
    elsif($cgi_type eq "bdr_guest") {
       print "<table width=$gTableWidth border=0 align=$gAlignType><tr><td>\n";    	    	
       if($gTitleUse eq "checked") {
          print "<br><center><img src=$gIMG_Guest/title.gif border=0></center><p>\n";
       }
    }
    elsif($cgi_type eq "bdr_link") {
       require "./lib/lk_preview.cgi";
       print "<table width=$gTableWidth border=0 align=$gAlignType><tr><td>\n";    	    	
       if(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
          print "<div id=\"overDiv\" style=\"position:absolute; left:0px; top:0px; z-index:1; visibility:hidden; border-style:none;\"></div>\n";
          &lk_preview;
       }
    }
    else {
       print "<table width=100% border=0 align=center><tr><td>\n";    	    	
    }    
}

##########################################################################
# html
##########################################################################
sub html_foot {
    require "./lib/cm_copyright.cgi";

    &copyright;
    print "\n</td></tr></table>\n";
    print "</body>\n";
    print "</html>\n";
    &get_server_info;
    exit;
}

##########################################################################
# htmlӸ   Beomdori's CGI̼ 
##########################################################################
sub copyright_contents {
    print "<!--
Program Name  : Beomdori's $cgi_name $cgi_ver
Programer     : BeomGyu Lee                
E-Mail        : cadeau\@orgio.net          
Homepage      : http://beomdori.x-y.net

Beomdori's CGI Ʒ׿ Ͻô и Ͻ  ֽϴ.

1.  ۱ úκ Ѽϸ ȵ˴ϴ.
   α׷ ҽ, htmlҽ ̼   ¹ ϴܿ ִ copyright link  ʽÿ.
   (۱ ǥô Խ  ۼ Ŀ  մϴ.)

2.   Ÿ ս  Ÿ ص    ؼ ڴ  å  ʽϴ.

3. ũ񽺵 ⺻ 뵵  ʴ  մϴ.

4. ҽ   Ͽ Ҽ   α׷  մϴ.
   (۱  κ Դϴ)

5. Ÿ ǹ http://beomdori.x-y.net  ̿ ֽñ ٶϴ.
   (    Խ Ͻʽÿ)

-->
          ";
}

##########################################################################
# htmlƷ   
##########################################################################
sub get_server_info {
    my $end_cpu_time = (times)[0]; # α׷  ð
    my $server_info = "\n<!--\n";
       $server_info .= ($ENV{'OS'}) ? "\$ENV{'OS'} = $ENV{'OS'}($^O)\n" : "Server OS         : $^O\n";
       $server_info .= sprintf("Perl Version      : v%vd\n", $^V);       
       $server_info .= "Gateway Interface : $ENV{'GATEWAY_INTERFACE'}\n" if($ENV{'GATEWAY_INTERFACE'});
       $server_info .= "HTTP Language     : $ENV{'HTTP_ACCEPT_LANGUAGE'}\n" if($ENV{'HTTP_ACCEPT_LANGUAGE'});
       $server_info .= "HTTP Host         : $ENV{'HTTP_HOST'}\n" if($ENV{'HTTP_HOST'});
       $server_info .= "Server Name       : $ENV{'SERVER_NAME'}\n" if($ENV{'SERVER_NAME'});       
       $server_info .= "Server Address    : $ENV{'SERVER_ADDR'}\n" if($ENV{'SERVER_ADDR'});
       $server_info .= "Server Protocol   : $ENV{'SERVER_PROTOCOL'}\n" if($ENV{'SERVER_PROTOCOL'});
       $server_info .= "Server Software   : $ENV{'SERVER_SOFTWARE'}\n" if($ENV{'SERVER_SOFTWARE'});
       $server_info .= sprintf("Processing Speed  : %.2f sec\n", $end_cpu_time - $start_cpu_time);
       $server_info .= "-->\n";
       print $server_info;
}
	
return 1;
